void draw()
{

  background(250);

  pushMatrix();
  pushStyle();


  // list of days
  pushMatrix();
  translate(110, (cfg.BarSize.y+cfg.BarSpace.y)*(dewey.length)+100);
  for (int i = 0; i<31; i++) {
    translate(cfg.BarSize.x+cfg.BarSpace.x, 0);

    //stroke(255);
    textFont(gFont1);
    fill(80);
    textAlign(CENTER, CENTER);
    text(str(i+1), 0, 0);
  }
  popMatrix();

  // list of dewey
  pushMatrix();
  translate(105, 50);  // if want to move, modify this!!
  for (int i = 0; i<dewey.length; i++) {
    translate(0, cfg.BarSize.y+cfg.BarSpace.y);

    textFont(gFont1);
    fill(80);
    textAlign(RIGHT, CENTER);
    text(dewey[i], 0, 0);  // do not modify pixel
  }
  popMatrix();

  // Title and copyright
  textFont(gFont2);
  textAlign(LEFT, CENTER);
  fill(80);
  text("Simple 2D Spatial Visualization - Dewey Category (700-800)", 120, 0, width, 80);

  textFont(gFont1);
  textAlign(CENTER, CENTER);
  text("# of Items\nChecked\nIn", 35, height/2);
  text("Days of January 2008", width/2+40, height-40);

  textAlign(RIGHT, BOTTOM);
  fill(180);
  text("by Yoon Chung Han | MAT259 Winter 2014", 0, 0, width-10, height-10);

  // draw each bar of musician
  pushMatrix();
  translate(cfg.BarPos.x, cfg.BarPos.y);
  translate(0, -(cfg.BarSize.y+cfg.BarSpace.y));
  for ( int i=0; i<gDataMatrices.length; i++ ) {

    translate(0, cfg.BarSize.y+cfg.BarSpace.y);

    for (int j=0; j<gDataMatrices[i].length; j++) {  // year
    
      pushMatrix();
      translate(-(cfg.BarSize.x+cfg.BarSpace.x), 0);
      
      for (int k=0; k<gDataMatrices[i][j].length; k++) {  // month
      
        translate(cfg.BarSize.x+cfg.BarSpace.x, 0);

        pushStyle();

        // normalize
        int nColor = (int)((float)gDataMatrices[i][j][k]/(float)max(gDataMatrices[i][j])*255.0f);  // mode 1
        //// no nomalization
        //int nColor = (int)((float)gDataMatrices[i][j][k]/(float)gMaxValue*255.0f);  // mode 1
        float mColor = map(nColor, 0, 255, 255, 0);
        //int nHue = (int)(240.0f - (float)gDataMatrices[i][j][k]/(float)gMaxValue*240.0f);  // mode2
        //float nColor2 = map(nColor, 0, 255, 50, 255); // mode3
        //float nColor3 = map(nColor, 0, 255, 30, 255); // mode3

        strokeWeight(0.2);
        stroke(150);
        fill(mColor, mColor, mColor);
        rect(0, 0, cfg.BarSize.x, cfg.BarSize.y);

        popStyle();
      }  // for k
      
      popMatrix();

    }  // for j

  }  // for i
  popMatrix();

  popStyle();
  popMatrix();
}

